const APP_DISPLAY_NAME = "DownloadWith";
const APP_NAME = "downloadwith";
const APP_PACKAGE = "/mozdev/downloadwith";
const APP_VERSION = "0.0.7";

const APP_JAR_FILE = "downloadwith.jar";
const APP_CONTENT_FOLDER = "content/downloadwith/";
const APP_LOCALES = ["en-US", "zh-TW"];

const APP_SUCCESS_MESSAGE = "DownloadWith should now be available on the context menu when you restart Mozilla.";

const INST_TO_PROFILE = "Do you wish to install "+APP_DISPLAY_NAME+" to your profile?\nThis will mean it does not need reinstalling when you update Mozilla.\n(Click Cancel if you want "+APP_DISPLAY_NAME+" installing to the Mozilla directory.)";
initInstall(APP_NAME, APP_PACKAGE, APP_VERSION);
// profile installs only work since 2003-03-06
var instToProfile = (buildID>2003030600 && confirm(INST_TO_PROFILE));

var chromef = instToProfile ? getFolder("Profile", "chrome") : getFolder("chrome");
var err = addFile(APP_PACKAGE, APP_VERSION, "chrome/" + APP_JAR_FILE, chromef, null)
if(err == SUCCESS) {
	var jar = getFolder(chromef, APP_JAR_FILE);
	if(instToProfile) {
  	registerChrome(CONTENT | PROFILE_CHROME, jar, APP_CONTENT_FOLDER);
	for(var j=APP_LOCALES.length; j-->0;) {
    registerChrome(LOCALE  | PROFILE_CHROME, jar, "locale/"+APP_LOCALES[j]+"/downloadwith/");
  }
  } else {
  	registerChrome(CONTENT | DELAYED_CHROME, jar, APP_CONTENT_FOLDER);
		for(var j=APP_LOCALES.length; j-->0;) {
			registerChrome(LOCALE  | DELAYED_CHROME, jar, "locale/"+APP_LOCALES[j]+"/downloadwith/");
		}
  }
	err = performInstall();
	if(err == SUCCESS || err == 999) {
		alert(APP_DISPLAY_NAME+" "+APP_VERSION+" has been succesfully installed.\n"+APP_SUCCESS_MESSAGE);
	} else {
		alert("Install failed. Error code:" + err);
		cancelInstall(err);
	}
} else {
	alert("Failed to create " +APP_JAR_FILE +"\n"
		+"You probably don't have appropriate permissions \n"
		+"(write access to your profile or chrome directory). \n"
		+"_____________________________\nError code:" + err);
	cancelInstall(err);
}